/*

Boost Software License - Version 1.0 - August 17th, 2003

Permission is hereby granted, free of charge, to any person or organization
obtaining a copy of the software and accompanying documentation covered by
this license (the "Software") to use, reproduce, display, distribute,
execute, and transmit the Software, and to prepare derivative works of the
Software, and to permit third-parties to whom the Software is furnished to
do so, all subject to the following:

The copyright notices in the Software and this entire statement, including
the above license grant, this restriction and the following disclaimer,
must be included in all copies of the Software, in whole or in part, and
all derivative works of the Software, unless such copies or derivative
works are solely in the form of machine-executable object code generated by
a source language processor.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
DEALINGS IN THE SOFTWARE.

*/
module derelict.sfml2.graphicstypes;

private import derelict.sfml2.systemtypes;

// Graphics/Types.h
struct sfCircleShape;
struct sfConvexShape;
struct sfFont;
struct sfImage;
struct sfShader;
struct sfRectangleShape;
struct sfRenderTexture;
struct sfRenderWindow;
struct sfShape;
struct sfSprite;
struct sfText;
struct sfTexture;
struct sfTransform;
struct sfTransformable;
struct sfVertexArray;
struct sfView;

// Graphics/BlendMode.h
alias int sfBlendMode;
enum
{
    sfBlendAlpha,
    sfBlendAdd,
    sfBlendMultiply,
    sfBlendNone,
}

// Graphics/Color.h
struct sfColor
{
    sfUint8 r;
    sfUint8 g;
    sfUint8 b;
    sfUint8 a;
}

immutable(sfColor) sfBlack = sfColor(0, 0, 0, 255);
immutable(sfColor) sfWhite = sfColor(255, 255, 255, 255);
immutable(sfColor) sfRed = sfColor(255, 0, 0, 255);
immutable(sfColor) sfGreen = sfColor(0, 255, 0, 255);
immutable(sfColor) sfBlue = sfColor(0, 0, 0, 255);
immutable(sfColor) sfYellow = sfColor(255, 255, 0, 255);
immutable(sfColor) sfMagenta = sfColor(255, 0, 255, 255);
immutable(sfColor) sfCyan = sfColor(0, 255, 255, 255);
immutable(sfColor) sfTransparent = sfColor(0, 0, 0, 0);

// Graphics/Glyph.h
struct sfGlyph
{
    int advance;
    sfIntRect bounds;
    sfIntRect textureRect;
}

// Graphics/PrimitiveType.h
alias int sfPrimitiveType;
enum
{
    sfPoints,
    sfLines,
    sfLinesStrip,
    sfTriangles,
    sfTrianglesStrip,
    sfTrianglesFan,
    sfQuads,
}

// Graphics/Rect.h
struct sfFloatRect
{
    float left;
    float top;
    float width;
    float height;
}

struct sfIntRect
{
    int left;
    int top;
    int width;
    int height;
}

// Graphics/RenderStates.h
struct sfRenderStates
{
    sfBlendMode blendMode;
    sfTransform* transform;
    const(sfTexture)* texture;
    const(sfShader)* shader;
}

// Graphics/Shape.h
extern(C)
{
    alias nothrow uint function(void*) sfShapeGetPointCountCallback;
    alias nothrow sfVector2f function(uint,void*) sfShapeGetPointCallback;
}

// Graphics/Text.h
alias int sfTextStyle;
enum
{
    sfTextRegular = 0,
    sfTextBold = 1 << 0,
    sfTextItalic = 1 << 1,
    sfTextUnderlined = 1 << 2,
}

// Graphics/Vertex.h
struct sfVertex
{
    sfVector2f position;
    sfColor color;
    sfVector2f texCoords;
}